#include "Ball.h"

CBall::CBall()
{
	m_BallShape.AddPoint(sf::Vector2f(375, 275)); //Ein
	m_BallShape.AddPoint(sf::Vector2f(375, 325)); //Quadrat, also der Ball,
	m_BallShape.AddPoint(sf::Vector2f(425, 325)); //wird
	m_BallShape.AddPoint(sf::Vector2f(425, 275)); //gezeichnet

	m_BallShape.EnableFill(true);

	this->Reset();

	m_BallRect.Left   = 375;
	m_BallRect.Top    = 275;
	m_BallRect.Right  = 425;
	m_BallRect.Bottom = 325;

	m_Offset.x = 10;
	m_Offset.y = 12;

	m_bIsAlive=true;

	m_Clock.Reset();
}

void CBall::Render(sf::RenderWindow &rw)
{
	if(m_bIsAlive==true)
		rw.Draw(m_BallShape);
}

void CBall::Reset()
{
	m_BallShape.SetPosition(sf::Vector2f(400, 300));
	m_Position=sf::Vector2f(400, 300);
}

void CBall::SetPosition(sf::Vector2f &Offset)
{
	if((m_Position.x>=0)||(m_Position.x<=800))
		m_Position.x+=Offset.x*m_fTime;
	else
		m_bIsAlive=false;

	if((m_Position.y>0)||(m_Position.y<600))
		m_Position.y+=Offset.y*m_fTime;
	else
		m_Position.y-=Offset.y*m_fTime;

	m_BallShape.SetPosition(m_Position);
}

void CBall::Update()
{
	m_fTime=m_Clock.GetElapsedTime();
	m_Clock.Reset();
	this->SetPosition(m_Offset);
}

bool CBall::CheckCollision(sf::IntRect &Rect)
{
	return m_BallRect.Intersects(Rect);
}